sc::SetIntCoor Class Reference

The SetIntCoor class describes a set of internal coordinates. More...

`#include <coor.h>`

Inheritance diagram for sc::SetIntCoor:
[legend]
Collaboration diagram for sc::SetIntCoor:
[legend]

## Public Member Functions

| SetIntCoor (StateIn &)
| SetIntCoor (const Ref< KeyVal > &)
| The KeyVal constructor. More...
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
void | add (const Ref< IntCoor > &)
| Adds an internal coordinate to the set.
void | add (const Ref< SetIntCoor > &)
| Adds all the elements of another set to this one.
void | pop ()
| Removes the last coordinate from this set.
void | clear ()
| Removes all coordinates from the set.
int | n () const
| Returns the number of coordinates in the set.
Ref< IntCoor > | coor (int i) const
| Returns a reference to the i'th coordinate in the set.
virtual void | fd_bmat (const Ref< Molecule > &, RefSCMatrix &)
| Compute the B matrix by finite displacements.
virtual void | bmat (const Ref< Molecule > &, RefSCMatrix &)
| Compute the B matrix the old-fashioned way.
virtual void | guess_hessian (Ref< Molecule > &, RefSymmSCMatrix &)
| Create an approximate Hessian for this set of coordinates. More...
virtual void | print_details (const Ref< Molecule > &, std::ostream &=ExEnv::out0()) const
| Print the coordinates in the set.
virtual void | update_values (const Ref< Molecule > &)
| Recalculate the values of the internal coordinates in the set.
virtual void | values_to_vector (const RefSCVector &)
| Copy the values of the internal coordinates to a vector.
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
virtual void | print (std::ostream &=ExEnv::out0()) const
| Print the object.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Additional Inherited Members

Static Public Member Functions inherited from sc::SavableState
static void | save_state (SavableState *s, StateOut &)
static SavableState * | restore_state (StateIn &si)
| Restores objects saved with save_state. More...
static SavableState * | key_restore_state (StateIn &si, const char *keyword)
| Like restore_state, but keyword is used to override values while restoring. More...
static SavableState * | dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)
Protected Member Functions inherited from sc::SavableState
| SavableState (const SavableState &)
| SavableState (StateIn &)
| Each derived class StateIn CTOR handles the restore corresponding to calling save_object_state, save_vbase_state, and save_data_state listed above. More...

## Detailed Description

The SetIntCoor class describes a set of internal coordinates.

It can automatically generate these coordinates using a integral coordinate generator object (see the IntCoorGen class) or the internal coordinates can be explicity given.

The following is a sample ParsedKeyVal input for a SetIntCoor object.

      setintcoor<SetIntCoor>: [
        <SumIntCoor>: (
          coor: [
            <StreSimpleCo>:( atoms = [ 1 2 ] )
            <StreSimpleCo>:( atoms = [ 2 3 ] )
            ]
          coef = [ 1.0 1.0 ]
          )
        <BendSimpleCo>:( atoms = [ 1 2 3 ] )
      ]

## Constructor & Destructor Documentation

sc::SetIntCoor::SetIntCoor | ( | const Ref< KeyVal > & |  | ) |

The KeyVal constructor.

`generator`

  A IntCoorGen object that will be used to generate the internal coordinates.

`i`

  A sequence of integer keywords, all for , can be assigned to IntCoor objects.

## Member Function Documentation

virtual void sc::SetIntCoor::guess_hessian | ( | Ref< Molecule > & | ,
|  | RefSymmSCMatrix & |
| ) |  |

virtual

Create an approximate Hessian for this set of coordinates.

This Hessian is a symmetric matrix whose i'th diagonal is the force constant for the i'th coordinate in the set.

void sc::SetIntCoor::save_data_state | ( | StateOut & |  | ) |

virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::SavableState.

The documentation for this class was generated from the following file:

- coor.h